#Filename:CH02_2.py
#多元計分的題目分析
import os
os.chdir('D:\\DATA\\CH02\\')
import pandas as pd
sdata0 = pd.read_csv('CH02_2.csv')
pnum = sdata0.shape[1]-1
snum = sdata0.shape[0]
print("資料的受試者人數 %4d 測驗題數 %4d"%(snum,pnum))
#建立另外一個資料檔
sdata2 = sdata0.copy()
#計算刪除後信度要將計分結果另存為sdata4
sdata4 = sdata2.drop(columns=['ID'])
#計算總分,將所要計算的串列標題儲存 c_sdata2
c_sdata2 = list(sdata2)
#第1個不用算,所以彈出
c_sdata2.pop(0)
sdata2['psum']=sdata2[c_sdata2].sum(axis='columns')
sdata2['pmean']=sdata2['psum']/pnum
#輸出平均數的描述性統計
sdata2['pmean'].describe()
lb=sdata2['psum'].quantile(0.27)
hb=sdata2['psum'].quantile(0.73)
sdata2.loc[sdata2.psum>0, 'grp']='M'
sdata2.loc[sdata2.psum>=hb, 'grp']='H'
sdata2.loc[sdata2.psum<=lb, 'grp']='L'
#計算分組難度,鑑別度,CR
import scipy.stats as stats
#計算第1題的CR值與P值
group1 = sdata2[c_sdata2[0]][sdata2['grp']=='H']
group2 = sdata2[c_sdata2[0]][sdata2['grp']=='L']
cr = stats.ttest_ind(group1,group2)
ph = (sdata2[c_sdata2[0]][sdata2['grp']=='H']).mean()
pl = (sdata2[c_sdata2[0]][sdata2['grp']=='L']).mean()
group3m = (ph+pl)/2
group4m = (ph-pl)

import pingouin as pg
from scipy.stats import pearsonr
from scipy.stats import spearmanr
#計算題目與總分相關
pcr=sdata2[c_sdata2[0]].corr(sdata2['psum'], method='pearson')
sdata3 = []
i=0
while (i <= pnum-1):
    sdata1_temp=[]
    #難度、標準差、偏態、峰度
    sdata1_temp.append(sdata2.iloc[:,i+1].mean())
    sdata1_temp.append(sdata2.iloc[:,i+1].std())
    sdata1_temp.append(sdata2.iloc[:,i+1].skew())
    sdata1_temp.append(sdata2.iloc[:,i+1].kurt())
    #計算分組難度
    ph = (sdata2[c_sdata2[i]][sdata2['grp']=='H']).mean()
    pl = (sdata2[c_sdata2[i]][sdata2['grp']=='L']).mean()
    sdata1_temp.append(ph)
    sdata1_temp.append(pl)
    sdata1_temp.append((ph+pl)/2)
    sdata1_temp.append(ph-pl)    
    #計算CR值
    cr = stats.ttest_ind(sdata2[c_sdata2[i]][sdata2['grp']=='H'],sdata2[c_sdata2[i]][sdata2['grp']=='L'])
    #cr值與p值
    sdata1_temp.append(cr.statistic)
    sdata1_temp.append(cr.pvalue)
    #題目與總分相關
    sdata1_temp.append(sdata2[c_sdata2[i]].corr(sdata2['psum'], method='pearson'))

    #計算刪題後信度
    sub_df = sdata4.drop(c_sdata2[i], axis=1)
    ac = pg.cronbach_alpha(sub_df)
    scale_mean = sub_df.mean().sum()
    variance = sub_df.sum(axis=1).var()
    pr = pearsonr(sub_df.mean(axis=1), sdata4[c_sdata2[i]])
    #計算Scale Mean if Item Deleted    
    sdata1_temp.append(scale_mean)
    #計算Scale Variance if Item Deleted
    sdata1_temp.append(variance)
    #計算Corrected Item-Total Correlation
    sdata1_temp.append(pr[0])
    #計算Cronbach's Alpha if Item Deleted
    sdata1_temp.append(ac[0])
    #將資料新增
    sdata3.append(sdata1_temp) 
    i=i+1
sdata3 = pd.DataFrame(sdata3)
sdata3.columns =['Mean','SD','Skew','Kurt','PH','PL','P','D','CR','p','r','SMean','SVar','Ir','IA']
print(sdata3)

Cresult = ''
Cresult = Cresult + 'No Mean SD Skew  Kurt  PH  PL  P  D  CR  p  r  SMean  SVar  Ir  IA \n'
for i in range(0, sdata3.shape[0]-1):
    Cresult = Cresult +'第'+str(i)+'題 '
    for j in range(0,sdata3.shape[1]-1):
        Cresult = Cresult+" "+str(sdata3.iloc[i][j].round(4))+" "
    Cresult = Cresult +'\n'

fp = open('result2.txt','w', encoding="utf-8")
print(Cresult, file=fp)
fp.close()