#Filename:CH03_2.py
#量表信度與效度分析(探索式因素分析)
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH03\\')
import pandas as pd
sdata0 = pd.read_csv('CH03_1.csv')
pnum = sdata0.shape[1]-1
snum = sdata0.shape[0]
#進行探索式因素分析前的檢驗工作
from factor_analyzer import FactorAnalyzer
#KMO
from factor_analyzer.factor_analyzer import calculate_kmo
kmo_all, kmo_model = calculate_kmo(sdata1)
print(kmo_all)
print(kmo_model)
#球形檢定
from factor_analyzer.factor_analyzer import calculate_bartlett_sphericity
chi_square_value, p_value = calculate_bartlett_sphericity(sdata1)
print(chi_square_value)
print(p_value)
#陡坡圖
fa = FactorAnalyzer(4, rotation= None)
fa.fit(sdata1)
#計算共同性
print(fa.get_communalities())
ev, v = fa.get_eigenvalues()
print(ev)
print(v)
#繪製陡坡圖
import matplotlib.pyplot as plt
plt.scatter(range(1,sdata1.shape[1]+1), ev)
plt.plot(range(1,sdata1.shape[1]+1),ev)
plt.title('Scree Plot')
plt.xlabel('Factor')
plt.ylabel('Eigenvalue')
plt.grid()
plt.show()
#計算解釋變異量
print(fa.get_factor_variance())
#輸出因素分析結果
loading = pd.DataFrame(fa.loadings_, columns=['因素1','因素2','因素3','因素4'], index=[sdata1.columns])
print(loading)
#轉軸
fa = FactorAnalyzer(method='minres', n_factors=4, rotation='varimax')
fa.fit(sdata1)
#計算共同性
print(fa.get_communalities())
ev, v = fa.get_eigenvalues()
print(ev)
print(v)
#計算解釋變異量
print(pd.DataFrame(fa.get_factor_variance(),index=['Variance','Proportional Var','Cumulative Var']))
loading = pd.DataFrame(fa.loadings_,index=sdata1.columns)
print(loading)
data_transformed = pd.DataFrame(fa.transform(sdata1), index = sdata1.index)
print(data_transformed)
#定義顯示的顏色
def color(val):
    if val >= 0.5 or val <=-0.5:
        color = '#2ecc71'
    elif val >=0.4 or val <=-0.4:
        color = '#f1c40f'
    else:
        color = 'white'
    return 'background-color: %s' % color
def font(val):
    if val >= 0.5 or val <=-0.5:
        color = 'black'
    elif val >=0.4 or val <=-0.4:
        color = 'black'
    else:
        color = 'black'
    return 'color: %s' % color
n_factors = 4
fa = FactorAnalyzer(method='minres', n_factors=n_factors, rotation= 'varimax')
fa.fit(sdata1)
loading = pd.DataFrame(fa.loadings_,index=sdata1.columns)
print(loading.round(4))
loading.round(4).style.applymap(color, subset=[i for i in range(n_factors)])
loading.round(4).style\
    .applymap(color, subset=[i for i in range(n_factors)])\
    .applymap(font, subset=[i for i in range(n_factors)])
#第2次,刪除B302,B301,B204
sdata2 = sdata1.drop(columns=['B302','B301','B204'])
n_factors = 4
fa = FactorAnalyzer(method='minres', n_factors=n_factors, rotation= 'varimax')
fa.fit(sdata2)
#顯示解釋變異的情形
variance = pd.DataFrame(fa.get_factor_variance(),index=['Variance','Proportional Var','Cumulative Var'])
print(variance)
#顯示因素負荷量的情形
loading = pd.DataFrame(fa.loadings_,index=sdata2.columns)
print(loading.round(4))
loading.round(4).style.applymap(color, subset=[i for i in range(n_factors)])
#第3次,B205與原構念不同,刪除
sdata3 = sdata2.drop(columns=['B205'])
n_factors = 4
fa = FactorAnalyzer(method='minres', n_factors=n_factors, rotation= 'varimax')
fa.fit(sdata3)
#顯示解釋變異的情形
variance = pd.DataFrame(fa.get_factor_variance(),index=['Variance','Proportional Var','Cumulative Var'])
print(variance)
#顯示因素負荷量的情形
loading = pd.DataFrame(fa.loadings_,index=sdata3.columns)
print(loading.round(4))
loading.round(4).style.applymap(color, subset=[i for i in range(n_factors)])
#第4次,更改轉軸解決交叉負荷的問題 varimax  promax
n_factors = 4
fa = FactorAnalyzer(method='principal', n_factors=n_factors, rotation= 'promax')
fa.fit(sdata3)
#顯示解釋變異的情形
variance = pd.DataFrame(fa.get_factor_variance(),index=['Variance','Proportional Var','Cumulative Var'])
print(variance)
#顯示因素負荷量的情形
loading = pd.DataFrame(fa.loadings_,index=sdata3.columns)
print(loading.round(4))
loading.round(4).style.applymap(color, subset=[i for i in range(n_factors)])