#Filename:CH04_2.py
#獨立樣本變異數分析
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH04\\')
#讀取資料
import pandas as pd
sdata0 = pd.read_csv('CH04_1.csv')
#檢視分析的欄位
print(sdata0.columns)
print(sdata0[['GENDER','JOB','A0101']].describe())
#開始進行單因子變異數分析
sdata1 = sdata0.copy()
sdata1['SA01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].sum(axis='columns')
sdata1['SA02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].sum(axis='columns')
sdata1['SA03']=sdata1[['A0301','A0302','A0303','A0304']].sum(axis='columns')
sdata1['SA04']=sdata1[['A0401','A0402','A0403']].sum(axis='columns')
sdata1['SA00']=sdata1[['SA01','SA02','SA03','SA04']].sum(axis='columns')
print(sdata1[['SA01','SA02','SA03','SA04','SA00']].describe())

sdata1['A01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].mean(axis='columns')
sdata1['A02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].mean(axis='columns')
sdata1['A03']=sdata1[['A0301','A0302','A0303','A0304']].mean(axis='columns')
sdata1['A04']=sdata1[['A0401','A0402','A0403']].mean(axis='columns')
sdata1['A00']=sdata1[['A01','A02','A03','A04']].mean(axis='columns')
print(sdata1[['A01','A02','A03','A04','A00']].describe().round(4))

import researchpy as rp
result = rp.summary_cont(sdata1['A01'].groupby(sdata0['JOB'])).round(4)
print(result)
result = rp.summary_cont(sdata1['A02'].groupby(sdata0['JOB'])).round(4)
print(result)
result = rp.summary_cont(sdata1['A03'].groupby(sdata0['JOB'])).round(4)
print(result)
result = rp.summary_cont(sdata1['A04'].groupby(sdata0['JOB'])).round(4)
print(result)
result = rp.summary_cont(sdata1['A00'].groupby(sdata0['JOB'])).round(4)
print(result)
#第1種方法變異數同質性檢定
import scipy.stats as stats
stats.levene(
    sdata1['A01'][sdata0['JOB']==1],
    sdata1['A01'][sdata0['JOB']==2],
    sdata1['A01'][sdata0['JOB']==3],
    sdata1['A01'][sdata0['JOB']==4],
    center='mean')
#進行單因子變異數分析,自變項是職務JOB,依變項是A01
import pingouin as pg
anova1 = pg.anova(dv ='A01', between='JOB', data=sdata1, detailed=True).round(4)
print(anova1)
#第2種方法利用scipy.stats進行ANOVA f_oneway()
group = sdata0['JOB'].unique()
args =[]
for i in list(group):
    args.append(sdata1[sdata1['JOB']==i]['A01'])

from scipy import stats
stats.levene(*args)    
stats.f_oneway(*args)

#第3種方法statsmodels
from statsmodels.formula.api import ols
import statsmodels.api as sm
anova2 = sm.stats.anova_lm(ols('A01~C(JOB)',sdata1).fit())
print(anova2.round(4))
#事後比較,因為達顯著,所以要進行事後比較
import pingouin as pg
result = pg.pairwise_ttests(dv='A01', between='JOB',padjust='bonf',data=sdata1).round(4)
print(result)
#A1.tukey
from statsmodels.stats.multicomp import pairwise_tukeyhsd
anovapost = pairwise_tukeyhsd(sdata1['A01'],sdata1['JOB'], alpha=0.05)
anovapost.summary()
#A2.tukey comp.tukeyhsd
import statsmodels.stats.multicomp as mc
comp = mc.MultiComparison(sdata1['A01'], sdata1['JOB'])
post_hoc_res = comp.tukeyhsd()
post_hoc_res.summary()
#B1.Bonferroni
import statsmodels.stats.multicomp as mc
comp = mc.MultiComparison(sdata1['A01'], sdata1['JOB'])
tb1, a1, a2 = comp.allpairtest(stats.ttest_ind, method='bonf')
print(tb1)

import researchpy as rp
rp.summary_cont(sdata1['A01'].groupby(sdata1['JOB'])).round(4)
rp.summary_cont(sdata1['A02'].groupby(sdata1['JOB'])).round(4)
rp.summary_cont(sdata1['A03'].groupby(sdata1['JOB'])).round(4)
rp.summary_cont(sdata1['A04'].groupby(sdata1['JOB'])).round(4)
rp.summary_cont(sdata1['A00'].groupby(sdata1['JOB'])).round(4)

import scipy.stats as stats
stats.levene(
    sdata1['A01'][sdata1['JOB']==1],
    sdata1['A01'][sdata1['JOB']==2],
    sdata1['A01'][sdata1['JOB']==3],
    sdata1['A01'][sdata1['JOB']==4],
    center='mean')
stats.levene(
    sdata1['A02'][sdata1['JOB']==1],
    sdata1['A02'][sdata1['JOB']==2],
    sdata1['A02'][sdata1['JOB']==3],
    sdata1['A02'][sdata1['JOB']==4],
    center='mean')
stats.levene(
    sdata1['A03'][sdata1['JOB']==1],
    sdata1['A03'][sdata1['JOB']==2],
    sdata1['A03'][sdata1['JOB']==3],
    sdata1['A03'][sdata1['JOB']==4],
    center='mean')
stats.levene(
    sdata1['A04'][sdata1['JOB']==1],
    sdata1['A04'][sdata1['JOB']==2],
    sdata1['A04'][sdata1['JOB']==3],
    sdata1['A04'][sdata1['JOB']==4],
    center='mean')
stats.levene(
    sdata1['A00'][sdata1['JOB']==1],
    sdata1['A00'][sdata1['JOB']==2],
    sdata1['A00'][sdata1['JOB']==3],
    sdata1['A00'][sdata1['JOB']==4],
    center='mean')
import pingouin as pg
anova1 = pg.anova(dv ='A01', between='JOB', data=sdata1, detailed=True).round(4)
anova2 = pg.anova(dv ='A02', between='JOB', data=sdata1, detailed=True).round(4)
anova3 = pg.anova(dv ='A03', between='JOB', data=sdata1, detailed=True).round(4)
anova4 = pg.anova(dv ='A04', between='JOB', data=sdata1, detailed=True).round(4)
anova0 = pg.anova(dv ='A00', between='JOB', data=sdata1, detailed=True).round(4)
print(anova1)
print(anova2)
print(anova3)
print(anova4)
print(anova0)

import statsmodels.stats.multicomp as mc
comp1 = mc.MultiComparison(sdata1['A01'], sdata1['JOB'])
po_t1 = comp1.tukeyhsd()
comp2 = mc.MultiComparison(sdata1['A01'], sdata1['JOB'])
po_t2 = comp2.tukeyhsd()
comp3 = mc.MultiComparison(sdata1['A01'], sdata1['JOB'])
po_t3 = comp3.tukeyhsd()
comp4 = mc.MultiComparison(sdata1['A01'], sdata1['JOB'])
po_t4 = comp4.tukeyhsd()
comp0 = mc.MultiComparison(sdata1['A01'], sdata1['JOB'])
po_t0 = comp0.tukeyhsd()
po_t1.summary()
po_t2.summary()
po_t3.summary()
po_t4.summary()
po_t0.summary()

import scikit_posthocs as sp
po_s1 = sp.posthoc_scheffe(sdata1, val_col='A01', group_col='JOB')
po_s2 = sp.posthoc_scheffe(sdata1, val_col='A02', group_col='JOB')
po_s3 = sp.posthoc_scheffe(sdata1, val_col='A03', group_col='JOB')
po_s4 = sp.posthoc_scheffe(sdata1, val_col='A04', group_col='JOB')
po_s0 = sp.posthoc_scheffe(sdata1, val_col='A00', group_col='JOB')

print(po_s1)
print(po_s2)
print(po_s3)
print(po_s4)
print(po_s0)