#Filename:CH04_3.py
#相依樣本變異數分析
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH04\\')
import pandas as pd
sdata0 = pd.read_csv('CH04_1.csv')
#檢視分析的欄位
print(sdata0.describe())
print(sdata0[['GENDER','JOB','A0101']].describe())

sdata1 = sdata0.copy()
sdata1['SA01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].sum(axis='columns')
sdata1['SA02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].sum(axis='columns')
sdata1['SA03']=sdata1[['A0301','A0302','A0303','A0304']].sum(axis='columns')
sdata1['SA04']=sdata1[['A0401','A0402','A0403']].sum(axis='columns')
sdata1['SA00']=sdata1[['SA01','SA02','SA03','SA04']].sum(axis='columns')
print(sdata1[['ID','SA01','SA02','SA03','SA04','SA00']].head(4))

sdata1['A01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].mean(axis='columns')
sdata1['A02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].mean(axis='columns')
sdata1['A03']=sdata1[['A0301','A0302','A0303','A0304']].mean(axis='columns')
sdata1['A04']=sdata1[['A0401','A0402','A0403']].mean(axis='columns')
sdata1['A00']=sdata1[['A01','A02','A03','A04']].mean(axis='columns')
print(sdata1[['ID','A01','A02','A03','A04','A00']].head(4))

import researchpy as rp
result = rp.summary_cont(sdata1['A01'].groupby(sdata1['JOB'])).round(4)
print(result)
result = rp.summary_cont(sdata1['A02'].groupby(sdata1['JOB'])).round(4)
print(result)
result = rp.summary_cont(sdata1['A03'].groupby(sdata1['JOB'])).round(4)
print(result)
result = rp.summary_cont(sdata1['A04'].groupby(sdata1['JOB'])).round(4)
print(result)
result = rp.summary_cont(sdata1['A00'].groupby(sdata1['JOB'])).round(4)
print(result)

import scipy.stats as stats
stats.levene(
    sdata1['A01'][sdata1['JOB']==1],
    sdata1['A01'][sdata1['JOB']==2],
    sdata1['A01'][sdata1['JOB']==3],
    sdata1['A01'][sdata1['JOB']==4],
    center='mean')
stats.levene(
    sdata1['A02'][sdata1['JOB']==1],
    sdata1['A02'][sdata1['JOB']==2],
    sdata1['A02'][sdata1['JOB']==3],
    sdata1['A02'][sdata1['JOB']==4],
    center='mean')
stats.levene(
    sdata1['A03'][sdata1['JOB']==1],
    sdata1['A03'][sdata1['JOB']==2],
    sdata1['A03'][sdata1['JOB']==3],
    sdata1['A03'][sdata1['JOB']==4],
    center='mean')
stats.levene(
    sdata1['A04'][sdata1['JOB']==1],
    sdata1['A04'][sdata1['JOB']==2],
    sdata1['A04'][sdata1['JOB']==3],
    sdata1['A04'][sdata1['JOB']==4],
    center='mean')
stats.levene(
    sdata1['A00'][sdata1['JOB']==1],
    sdata1['A00'][sdata1['JOB']==2],
    sdata1['A00'][sdata1['JOB']==3],
    sdata1['A00'][sdata1['JOB']==4],
    center='mean')

wide_format = sdata1[['ID','A01','A02','A03','A04']]
long_format = pd.melt(wide_format, id_vars='ID',value_vars=['A01','A02','A03','A04'],var_name='AN',value_name='AV')

print(long_format.sort_values('ID').head(10))

#繪製盒子圖
import matplotlib.pyplot as plt
import seaborn as sns
ax = sns.boxplot(x='AN',y='AV', data=long_format, color='#99c2a2')
ax = sns.swarmplot(x='AN',y='AV', data=long_format, color='#7d0013')
plt.show()

from dfply import *
print(long_format >> group_by(X.AN) >>summarize(n=X.AV.count(), mean=X.AV.mean(), std=X.AV.std()))
#進行重覆量數變異數分析
import pingouin as pg
rmanova = pg.rm_anova(dv='AV',within='AN',subject='ID',correction=False,data=long_format,detailed=True, effsize='ng2')
print(rmanova)

post_hocs = pg.pairwise_ttests(dv='AV', within='AN', subject='ID', padjust='fdr_bh', data=long_format)
print(post_hocs.round(4))
result = pg.normality(data=long_format, dv='AV', group='AN')
print(result)