#Filename: CH05_1.py
#共變數分析
import os
os.chdir('D:\\DATA\\CH05\\')
import pandas as pd
sdata0 = pd.read_csv('CH05_1.csv')

print(sdata0.head())
print(sdata0.tail())

sdata0.GROUP.value_counts()
sdata0.GENDER.value_counts()

import researchpy as rp
pgroup = rp.summary_cont(sdata0['BPRE'].groupby(sdata0['GROUP'])).round(4)
print(pgroup)
pgender = rp.summary_cont(sdata0['BPOST'].groupby(sdata0['GROUP'])).round(4)
print(pgender)

from statsmodels.formula.api import ols
from statsmodels.stats.anova import anova_lm
interaction_model = ols('BPOST ~ BPRE * GROUP', data=sdata0).fit()
result = anova_lm(interaction_model, type=3)
print(result)

import pingouin as pg
result = pg.ancova(data=sdata0, dv='BPOST', covar='BPRE', between='GROUP')
print(result)

from statsmodels.formula.api import ols
model = ols('BPOST ~ BPRE + GROUP', data=sdata0).fit()
print(model.summary())

from plotly import express
express.scatter(
    sdata0.assign(GROUP=sdata0['GROUP'].astype(str)),
    x='BPRE',
    y='BPOST',
    color='GROUP',    
    trendline='ols',
    title='BPRE BPOST GROUP',
    template = "simple_white",
    height =600, width=800, 
    labels={
        'BPRE':'BPRE DATA',
        'BPOST':'BPOST DATA'
    }
)