#Filename: CH05_2.py
#共變數分析(大學生逃避行為實驗共變分析)
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH05\\')

import pandas as pd
sdata0 = pd.read_csv('CH05_2.csv')
#檢視資料
print(sdata0.head())
print(sdata0.tail())

#1.這個步驟很重要, 需要將group轉為類別變項
print(sdata0.info())
sdata0 = sdata0.astype({'GROUP':'object'})
print(sdata0.info())

#2.計算男生幾位,女生幾位,實驗組幾位,控制組幾位
result = sdata0.GROUP.value_counts()
print(result)

import researchpy as rp
result = rp.summary_cont(sdata0['PRE'].groupby(sdata0['GROUP'])).round(4)
print(result)
result = rp.summary_cont(sdata0['POST'].groupby(sdata0['GROUP'])).round(4)
print(result)

#3.迴歸同質性檢定
from statsmodels.formula.api import ols
from statsmodels.stats.anova import anova_lm
interaction_model = ols('POST ~ PRE * GROUP', data=sdata0).fit()
result = anova_lm(interaction_model, type=3)
print(result)

#4.共變數分析  BPOST:依變項 BPRE:共變項 GROUP:自變項
import pingouin as pg
result = pg.ancova(data=sdata0, dv='POST', covar='PRE', between='GROUP')
print(result)

#5.比較效果的差異
model = ols('POST ~ PRE + GROUP', data=sdata0).fit()
print(model.summary())

#6.繪製圖形
from plotly import express
express.scatter(
    sdata0.assign(GROUP=sdata0['GROUP'].astype(str)),
    x='PRE',
    y='POST',
    color='GROUP',    
    trendline='ols',
    title='PRE POST GROUP',
    template = "simple_white",
    height =600, width=800, 
    labels={
        'PRE':'PRE DATA',
        'POST':'POST DATA'
    }
)