#Filename:CH06_2.py
#迴歸分析
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH06\\')
import pandas as pd
sdata0 = pd.read_csv('CH06_1.csv')
sdata1 = sdata0.copy()

#A總和
sdata1['A01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].sum(axis='columns')
sdata1['A02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].sum(axis='columns')
sdata1['A03']=sdata1[['A0301','A0302','A0303','A0304']].sum(axis='columns')
sdata1['A04']=sdata1[['A0401','A0402','A0403']].sum(axis='columns')
sdata1['A00']=sdata1[['A01','A02','A03','A04']].sum(axis='columns')
#A單題平均
sdata1['SA01']=sdata1[['A0101','A0102','A0103','A0104','A0105','A0106']].mean(axis='columns')
sdata1['SA02']=sdata1[['A0201','A0202','A0203','A0204','A0205','A0206']].mean(axis='columns')
sdata1['SA03']=sdata1[['A0301','A0302','A0303','A0304']].mean(axis='columns')
sdata1['SA04']=sdata1[['A0401','A0402','A0403']].mean(axis='columns')
sdata1['SA00']=sdata1[['SA01','SA02','SA03','SA04']].mean(axis='columns')
#B總和
sdata1['B01']=sdata1[['B0101','B0102','B0103','B0104','B0105','B0106','B0107','B0108']].sum(axis='columns')
sdata1['B02']=sdata1[['B0201','B0202','B0203','B0204','B0205','B0206']].sum(axis='columns')
sdata1['B03']=sdata1[['B0301','B0302','B0303','B0304']].sum(axis='columns')
sdata1['B04']=sdata1[['B0401','B0402','B0403']].sum(axis='columns')
sdata1['B00']=sdata1[['B01','B02','B03','B04']].sum(axis='columns')
#B單題平均
sdata1['SB01']=sdata1[['B0101','B0102','B0103','B0104','B0105','B0106','B0107','B0108']].mean(axis='columns')
sdata1['SB02']=sdata1[['B0201','B0202','B0203','B0204','B0205','B0206']].mean(axis='columns')
sdata1['SB03']=sdata1[['B0301','B0302','B0303','B0304']].mean(axis='columns')
sdata1['SB04']=sdata1[['B0401','B0402','B0403']].mean(axis='columns')
sdata1['SB00']=sdata1[['SB01','SB02','SB03','SB04']].mean(axis='columns')
#C總和
sdata1['C01']=sdata1[['C0101','C0102','C0103','C0104','C0105','C0106','C0107']].sum(axis='columns')
sdata1['C02']=sdata1[['C0201','C0202','C0203','C0204','C0205']].sum(axis='columns')
sdata1['C03']=sdata1[['C0301','C0302','C0303','C0304']].sum(axis='columns')
sdata1['C04']=sdata1[['C0401','C0402','C0403','C0404']].sum(axis='columns')
sdata1['C00']=sdata1[['C01','C02','C03','C04']].sum(axis='columns')
#C單題平均
sdata1['SC01']=sdata1[['C0101','C0102','C0103','C0104','C0105','C0106','C0107']].mean(axis='columns')
sdata1['SC02']=sdata1[['C0201','C0202','C0203','C0204','C0205']].mean(axis='columns')
sdata1['SC03']=sdata1[['C0301','C0302','C0303','C0304']].mean(axis='columns')
sdata1['SC04']=sdata1[['C0401','C0402','C0403','C0404']].mean(axis='columns')
sdata1['SC00']=sdata1[['SC01','SC02','SC03','SC04']].mean(axis='columns')
#繪圖
#1.pandas
sdata1.plot.scatter(x='A00',y='B00')
#2.matplotlib
import matplotlib.pyplot as plt
plt.scatter(sdata1['A00'],sdata1['B00'], c='darkblue', alpha=0.5)
plt.show()
#3.seaborn
import seaborn as sns
sns.scatterplot(x='A00',y='B00', data=sdata1)

#進行簡單迴歸分析
import scipy.stats as stats
#依變項前面,自變項後面
result1 = stats.linregress(sdata1['A00'], sdata1['B00'])
print(result1)

import statsmodels.api as sm1
y=sdata1['B00']
x=sdata1['A00']
x_c=sm1.add_constant(x)
result2=sm1.OLS(y,x_c).fit()
print(result2.summary())

import statsmodels.formula.api as sm2
result3 = sm2.ols('B00 ~ A00', sdata1).fit()
print(result3.summary())
#計算標準化解
sdata2 = sdata1[['A00','B00']]
zsdata2 = sdata2.apply(stats.zscore)
result31 = sm2.ols('B00 ~ A00', zsdata2).fit()
print(result31.summary())

import pingouin as pg
result4 = pg.linear_regression(sdata1['A00'],sdata1['B00'])
print(result4.round(4))

import matplotlib.pyplot as plt
#以下2行是為了要顯示中文才要新增的
plt.rcParams['font.sans-serif']=['Microsoft JhengHei']
plt.rcParams['axes.unicode_minus']=False
plt.figure(figsize=(8,6))
plt.scatter(x,y,c='k', marker='o')
plt.plot(x,result2.params[0]+result2.params[1]*x,'r')
plt.xlabel('教師領導')
plt.ylabel('教師專業學習社群')
plt.title('教師領導預測教師專業學習社群')
plt.grid()
#多元迴歸
#(1)ENTER
result51 = sm2.ols('B00 ~ A01+A02+A03+A04', sdata1).fit()
print(result51.summary())
#刪除A02
result52 = sm2.ols('B00 ~ A01+A03+A04', sdata1).fit()
print(result52.summary())
#計算標準化解
sdata2 = sdata1[['A01','A03','A04','B00']]
zsdata2 = sdata2.apply(stats.zscore)
result53 = sm2.ols('B00 ~ A01+A03+A04', zsdata2).fit()
print(result53.summary())
#(2)STEPWISE
import pandas as pd
import numpy as np
import statsmodels.api as sm
def stepwise_selection(X, y, 
                       initial_list=[], 
                       threshold_in=0.01, 
                       threshold_out = 0.05, 
                       verbose=True):
    included = list(initial_list)
    while True:
        changed=False
        # forward
        excluded = list(set(X.columns)-set(included))
        new_pval = pd.Series(index=excluded)
        new_tval = pd.Series(index=excluded)
        for new_column in excluded:
            model = sm.OLS(y, sm.add_constant(pd.DataFrame(X[included+[new_column]]))).fit()
            new_pval[new_column] = model.pvalues[new_column]
            new_tval[new_column] = model.tvalues[new_column]
        best_pval = new_pval.min()
        best_tval = new_tval.max()
        if best_pval < threshold_in:
            best_feature = new_pval.idxmin()
            included.append(best_feature)
            changed=True
            if verbose:
                print('Add  {:30} with p-value {:.6} t-value {:.6}'.format(best_feature, best_pval, best_tval))
        # backward
        model = sm.OLS(y, sm.add_constant(pd.DataFrame(X[included]))).fit()

        pvalues = model.pvalues.iloc[1:]
        worst_pval = pvalues.max() # null if pvalues is empty
        if worst_pval > threshold_out:
            changed=True
            worst_feature = pvalues.idxmax()
            included.remove(worst_feature)
            if verbose:
                print('Drop {:30} with p-value {:.6}'.format(worst_feature, worst_pval))
        if not changed:
            break
    return included

X=sdata1[['A01','A02','A03','A04']]
y=sdata1[['B00']]
result = stepwise_selection(X, y)
print('resulting features:')
print(result)
#建立逐步迴歸的模式
result63 = sm2.ols('B00 ~ A03+A01+A04', sdata1).fit()
print(result63.summary())
#標準化解
sdata2 = sdata1[['A03','A01','A04','B00']]
zsdata2 = sdata2.apply(stats.zscore)
result631 = sm2.ols('B00 ~ A03+A01+A04', zsdata2).fit()
print(result631.summary())

result62 = sm2.ols('B00 ~ A03+A01', sdata1).fit()
print(result62.summary())
#標準化解
sdata2 = sdata1[['A03','A01','B00']]
zsdata2 = sdata2.apply(stats.zscore)
result621 = sm2.ols('B00 ~ A03+A01', zsdata2).fit()
print(result621.summary())

result61 = sm2.ols('B00 ~ A03', sdata1).fit()
print(result61.summary())

#標準化解
sdata2 = sdata1[['A03','B00']]
zsdata2 = sdata2.apply(stats.zscore)
result611 = sm2.ols('B00 ~ A03', zsdata2).fit()
print(result611.summary())

#共線性診斷
from statsmodels.formula.api import ols
def vif(df, col_i):
    cols = list(df.columns)
    cols.remove(col_i)
    cols_noti = cols
    formula = col_i + '~' + '+'.join(cols_noti)
    r2 = ols(formula, df).fit().rsquared
    return 1. / (1. - r2)

vifdata = sdata1[['A03', 'A01', 'A04']]
for i in vifdata.columns:
    pvif=vif(df=vifdata, col_i=i)
    ptot=1/pvif
    print(i, '\t', ptot, '\t', pvif)