#Filename:CH07_1.py
#卡方分析
#顯示卡方的機率值
from scipy import stats
print(stats.chi2.ppf(0.95,4))
print(1-stats.chi2.cdf(6.24,4))
print(stats.chi2.ppf(0.95,1))
print(1-stats.chi2.cdf(0.5655,1))
print(stats.chi2.ppf(0.95,6))
print(1-stats.chi2.cdf(31.6618,6))
#開始進行卡方考驗
#更改工作目錄
import os
os.chdir('D:\\DATA\\CH07\\')
#1.適合度檢定
sdata0=[96,104]
import scipy.stats as stats
result1=stats.chisquare(sdata0)
print(result1)

result11=stats.chisquare(sdata0, [100,100])
print(result11)

sdata11=[168,32]
sdata12=[180,20]
result2=stats.chisquare(sdata11, sdata12)
print(result2)

#2.獨立性檢定
import pandas as pd
sdata31 = [[88,22],[84,16]]
sdata31 = pd.DataFrame(sdata31)
result3=stats.chi2_contingency(sdata31)
print(result3)
#因為是2*2列聯表，所以需要進行葉慈校正Yates correction,亦即correction要設定為False
result3=stats.chi2_contingency(sdata31, correction=False)
print(result3)

#3.同質性檢定
import pandas as pd
sdata4 = [[23,27,5,31],[5,4,6,10],[3,12,9,50]]
sdata4 = pd.DataFrame(sdata4)
result4=stats.chi2_contingency(sdata4, correction=False)
print(result4)
#計算臨界值
print(stats.chi2.ppf(0.95,6))
c1= sdata4.sum()
ncols=len(c1)
r1=sdata4.sum(axis=1)
nrows=len(r1)
n=sum(r1)
exp=result4[3]
#將它變成分開的dataframe比較容易閱讀
phres = pd.DataFrame(columns=['Row','Col','adjres'])
for i in range(nrows):
    for j in range(ncols):
        adjres = (sdata4.iloc[i,j]-exp[i,j])/(exp[i,j]*(1-r1[i]/n)*(1-c1[j]/n))**0.5
        phres=phres.append({'Row':sdata4.index[i],'Col':sdata4.columns[j],'adjres':adjres},ignore_index=1)
print(phres)
#調整後的殘差一般被為Z分數,所以將它pvalue/sig.利用標準化常態分配,norm.cdf的函數從 scipy.stats.
from scipy.stats import norm
phres['sig']=2*(1-norm.cdf(abs(phres['adjres'])))
#調整pvalue
phres['adjsig']=phres.shape[0]*phres['sig']
#部分adjsig超過,理論上這是不可能的,將它取代為1
phres.loc[phres['adjsig']>1,'adjsig']=1
print(phres)